﻿using System;
using System.IO;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using Microsoft.Win32;
using Model;

namespace infragisticsTest.Chart.View
{
    /// <summary>
    /// Interaction logic for ChartView.xaml
    /// </summary>
    public partial class ChartView : UserControl
    {
        public ChartView()
        {
            InitializeComponent();
        }

        private void XamMenuItem_OnClick(object sender, EventArgs e)
        {
            ExportElementToImage(ContainerGrid);
        }

        private static void ExportElementToImage(FrameworkElement target)
        {
            const int dpi = 96;

            var width = Convert.ToInt32(target.ActualWidth);
            var height = Convert.ToInt32(target.ActualHeight);

            var bitmap = new RenderTargetBitmap(width, height, dpi, dpi, PixelFormats.Pbgra32);
            bitmap.Render(target);
            var dialog = new SaveFileDialog
            {
                Filter = "PNG files|*.png",
                DefaultExt = "png"
            };

            if (!(dialog.ShowDialog() == true))
            {
                return;
            }
            using (Stream stream = dialog.OpenFile())
            {
                var encoder = new PngBitmapEncoder();
                encoder.Frames.Add(BitmapFrame.Create((bitmap)));
                encoder.Save(stream);
            }

        }
    }
}
